From b3d7bb12fb55dee7b09095b1ecefe02c8a92c0dd Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 27 2020 23:59:03 +0000
Subject: [PATCH 1593/2232] Move PartialEq related derive logic to derive module


---

diff --git a/macro/src/derive.rs b/macro/src/derive.rs
index 2109a1f..22c05cc 100644
--- a/macro/src/derive.rs
+++ b/macro/src/derive.rs
@@ -17,7 +17,7 @@ pub fn expand_struct(strct: &Struct) -> TokenStream {
     expanded
 }
 
-pub fn expand_enum(enm: &Enum) -> TokenStream {
+pub fn expand_enum(enm: &Enum, actual_derives: &mut Option<TokenStream>) -> TokenStream {
     let mut expanded = TokenStream::new();
     let mut has_copy = false;
     let mut has_clone = false;
@@ -45,6 +45,12 @@ pub fn expand_enum(enm: &Enum) -> TokenStream {
         expanded.extend(enum_clone(enm, span));
     }
 
+    *actual_derives = Some(quote! {
+        // Required to be derived in order for the enum's "variants" to be
+        // usable in patterns.
+        #[derive(::std::cmp::PartialEq, ::std::cmp::Eq)]
+    });
+
     expanded
 }
 
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 2917820..cc55101 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -164,12 +164,8 @@ fn expand_enum(enm: &Enum) -> TokenStream {
             pub const #variant_ident: Self = #ident { repr: #discriminant };
         })
     });
-    let derives = quote! {
-        // Required to be derived in order for the enum's "variants" to be
-        // usable in patterns.
-        #[derive(::std::cmp::PartialEq, ::std::cmp::Eq)]
-    };
-    let derived_traits = derive::expand_enum(enm);
+    let mut derives = None;
+    let derived_traits = derive::expand_enum(enm, &mut derives);
 
     quote! {
         #doc

